#!/usr/bin/perl -I/usr/sausalito/perl
# $Id: vpscron.pl

use CCE;
require LWP::UserAgent;

$cce = new CCE;
$cce->connectuds;

# Sleep for a random amount of time, but no longer than 5 minutes:
sleep rand(300);

# Get primary IP and it's MAC:
@network_oid = $cce->find('Network', {'device' => 'br0'});
($ok, $Network) = $cce->get($network_oid[0]);
if ($ok) {
        $IP = $Network->{'ipaddr'};
        $MAC = `/bin/cat /sys/class/net/br0/address`;
	chomp($MAC);
}
else {
	#print "Unable to fetch IP and MAC of Network Device 'br0'!\n";
        $cce->bye('SUCCESS');
	exit(1);
}

# Connect to AdmServ's cron page:
my $ua = LWP::UserAgent->new;
my $response = $ua->get("http://127.0.0.1:444/vserver/vpscron?IP=$IP&MAC=$MAC");

# Status check:
if ($response->is_success) {
    # It worked. We exit silently. Uncomment the line below for debug:
    #print $response->status_line . "\n";
    $cce->bye('SUCCESS');
    exit(0);
}
else {
    # That didn't work. Make a bit of noise about it:
    #print "Connect to AdmServ failed\n";
    $cce->bye('SUCCESS');
    exit(1);
}

$cce->bye('SUCCESS');
exit(0);

# 
# Copyright (c) 2016 Michael Stauber, SOLARSPEED.NET
# Copyright (c) 2016 Team BlueOnyx, BLUEONYX.IT
# All Rights Reserved.
# 
# 1. Redistributions of source code must retain the above copyright 
#     notice, this list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright 
#     notice, this list of conditions and the following disclaimer in 
#     the documentation and/or other materials provided with the 
#     distribution.
# 
# 3. Neither the name of the copyright holder nor the names of its 
#     contributors may be used to endorse or promote products derived 
#     from this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
# COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
# POSSIBILITY OF SUCH DAMAGE.
# 
# You acknowledge that this software is not designed or intended for 
# use in the design, construction, operation or maintenance of any 
# nuclear facility.
# 
